#include "LCD_I2C.c"	   // I2C LCD Ktphanesi

// Connections
sbit LED    at LATA4_bit;  // Dahili LED RA4 Pinine Bagli

unsigned short i;          // Dng islemlerinde kullanilacak index degiskeni

void main() {
  // Port Giris-ikis Seimi (0:ikis, 1:Giris)
  TRISA=0b00000000; // [][][][LED][][][][]
  TRISB=0b00000000; // [][][][][][][SCK][SDA]
  TRISC=0b00000000; // [][][][][][][][]
  TRISD=0b00000000; // [][][][][][][][]
  TRISE=0b00000000; // [][][][][][][][]

  // Port Analog-Dijital Giris Seimi (0:Dijital, 1:Analog)
  ANSELA=0b00000000; // [][][][][][][][]
  ANSELB=0b00000000; // [][][][][][][][]
  ANSELC=0b00000000; // [][][][][][][][]
  ANSELD=0b00000000; // [][][][][][][][]
  ANSELE=0b00000000; // [][][][][][][][]

  // Port Temizleme
  LATA=0x00;
  LATB=0x00;
  LATC=0x00;
  LATD=0x00;
  LATE=0x00;
  
  // I2C Hazirlama
  I2C1_Init(100000);                    // I2C LCD ktphanesi dahili I2C donanimi ile alismaktadir.

  // LCD Ekran Hazirlama
  LCD_Init();                           // Ekrani hazirla
  LCD_Cmd(_LCD_CURSOR_OFF);             // Imleci kapat
  LCD_Cmd(_LCD_CLEAR);                  // Ekrani temizle

  // Sonsuz Dongu
  while(1){
    Lcd_Cmd(_LCD_CLEAR);                // Ekrani temizle

    Lcd_Out(1,6,"TRUDYO");              // 1.Satir 6.Sutuna yaz
    Lcd_Out(2,2,"MAKER BLOG IS");       // 2.Satir 2.Sutuna yaz
    Lcd_Out_CP("!");                    // Imlec konumuna '!' yaz (Bir nceki komutta imlec 2.satir 15.sutunda kalmisti

    delay_ms(2000);                     // 2 saniye bekleme

    Lcd_Cmd(_LCD_CLEAR);                // Ekrani temizle
    Lcd_Chr(2,4,'L'); delay_ms(150);    // 2.satir 4.stuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('O');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('A');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('D');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('I');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('N');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('G');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('.');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('.');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.
    Lcd_Chr_Cp('.');  delay_ms(150);    // Imlec konumuna yaz ve 150ms bekle.

    delay_ms(2000);                     // 2 saniye bekleme

    Lcd_Cmd(_LCD_CLEAR);                // Ekrani temizle
    Lcd_Out(1,1,"WELCOME TO");          // 1.Satir 1.Sutuna yaz
    Lcd_Out(2,1,"MAKER BLOG");          // 2.Satir 1.Sutuna yaz
    delay_ms(500);                      // 500ms bekle

    while(1){                           // Sonsuz dng
      for(i=0;i<6;i++){                 // 6 turluk dng
        Lcd_Cmd(_LCD_SHIFT_RIGHT);      // tm ekrani bir kez saga kaydir
        delay_ms(500);                  // 500ms bekle
      }
      for(i=0;i<6;i++){                 // 6 turluk dng
        Lcd_Cmd(_LCD_SHIFT_LEFT);       // tm ekrani bir kez sola kaydir
        delay_ms(500);                  // 500ms bekle
      }
    }
  }
}