#line 1 "C:/Users/uemin/Desktop/mikroC/2x16 I2C LCD Uygulamasi/main.c"
#line 1 "c:/users/uemin/desktop/mikroc/2x16 i2c lcd uygulamasi/lcd_i2c.c"
#line 21 "c:/users/uemin/desktop/mikroc/2x16 i2c lcd uygulamasi/lcd_i2c.c"
const unsigned short HEX00=0x00;
const unsigned short HEX01=0x01;
const unsigned short HEX04=0x04;
const unsigned short HEX06=0x06;
const unsigned short HEX08=0x08;
const unsigned short HEX20=0x20;
const unsigned short HEX28=0x28;
const unsigned short HEX30=0x30;
const unsigned short HEX80=0x80;
const unsigned short HEX94=0x94;
const unsigned short HEXC0=0xC0;
const unsigned short HEXD4=0xD4;
const unsigned short HEXF0=0xF0;

void LCD_Cmd(char out_char) {
 char hi_n, lo_n;
 char rs = HEX00;

 hi_n = out_char & HEXF0;
 lo_n = (out_char << 4) & HEXF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();
 I2C1_Wr(hi_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(hi_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 I2C1_stop();

 if(out_char == HEX01)
 Delay_ms(2);
}

void LCD_Chr(char row, char column, char out_char) {
 char hi_n, lo_n;
 char rs = HEX01;

 column--;
 switch(row){
 case 1:
 LCD_Cmd(HEX80+column);
 break;
 case 2:
 LCD_Cmd(HEXC0+column);
 break;
 case 3:
 LCD_Cmd(HEX94+column);
 break;
 case 4:
 LCD_Cmd(HEXD4+column);
 break;
 };

 hi_n = out_char & HEXF0;
 lo_n = (out_char << 4) & HEXF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();
 I2C1_Wr(hi_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(hi_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 I2C1_stop();
}

void LCD_Chr_Cp(char out_char) {
 char hi_n, lo_n;
 char rs = HEX01;

 hi_n = out_char & HEXF0;
 lo_n = (out_char << 4) & HEXF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();
 I2C1_Wr(hi_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(hi_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 I2C1_stop();
}


void LCD_Init() {
 char rs = HEX00;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();

 Delay_10ms();
 Delay_10ms();
 Delay_10ms();

 I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
 I2C1_Is_Idle();

 Delay_10ms();

 I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
 I2C1_Is_Idle();

 Delay_10ms();

 I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_10ms();
 Delay_10ms();
 Delay_10ms();
 Delay_10ms();
 Delay_10ms();
 I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
 I2C1_Is_Idle();

 Delay_10ms();

 I2C1_Wr(HEX20 | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(HEX20 | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 I2C1_Stop();

 Delay_10ms();

 LCD_Cmd(HEX28);
 LCD_Cmd(HEX06);
}

void LCD_Out(char row, char col, char *text) {
 while(*text)
 LCD_Chr(row, col++, *text++);
}

void LCD_Out_Cp(char *text) {
 while(*text)
 LCD_Chr_Cp(*text++);
}
#line 4 "C:/Users/uemin/Desktop/mikroC/2x16 I2C LCD Uygulamasi/main.c"
sbit LED at LATA4_bit;

unsigned short i;

void main() {

 TRISA=0b00000000;
 TRISB=0b00000000;
 TRISC=0b00000000;
 TRISD=0b00000000;
 TRISE=0b00000000;


 ANSELA=0b00000000;
 ANSELB=0b00000000;
 ANSELC=0b00000000;
 ANSELD=0b00000000;
 ANSELE=0b00000000;


 LATA=0x00;
 LATB=0x00;
 LATC=0x00;
 LATD=0x00;
 LATE=0x00;


 I2C1_Init(100000);


 LCD_Init();
 LCD_Cmd( 0x0C );
 LCD_Cmd( 0x01 );


 while(1){
 Lcd_Cmd( 0x01 );

 Lcd_Out(1,6,"TRUDYO");
 Lcd_Out(2,2,"MAKER BLOG IS");
 Lcd_Out_CP("!");

 delay_ms(2000);

 Lcd_Cmd( 0x01 );
 Lcd_Chr(2,4,'L'); delay_ms(150);
 Lcd_Chr_Cp('O'); delay_ms(150);
 Lcd_Chr_Cp('A'); delay_ms(150);
 Lcd_Chr_Cp('D'); delay_ms(150);
 Lcd_Chr_Cp('I'); delay_ms(150);
 Lcd_Chr_Cp('N'); delay_ms(150);
 Lcd_Chr_Cp('G'); delay_ms(150);
 Lcd_Chr_Cp('.'); delay_ms(150);
 Lcd_Chr_Cp('.'); delay_ms(150);
 Lcd_Chr_Cp('.'); delay_ms(150);

 delay_ms(2000);

 Lcd_Cmd( 0x01 );
 Lcd_Out(1,1,"WELCOME TO");
 Lcd_Out(2,1,"MAKER BLOG");
 delay_ms(500);

 while(1){
 for(i=0;i<6;i++){
 Lcd_Cmd( 0x1E );
 delay_ms(500);
 }
 for(i=0;i<6;i++){
 Lcd_Cmd( 0x18 );
 delay_ms(500);
 }
 }
 }
}
